package it.eng.test.remote.helloconsumer;

import it.eng.test.remote.hello.IHello;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import ch.ethz.iks.r_osgi.RemoteOSGiService;
import ch.ethz.iks.r_osgi.RemoteServiceReference;
import ch.ethz.iks.r_osgi.URI;

public class Activator implements BundleActivator {

	private BundleContext context;

	public BundleContext getContext() {
		return context;
	}
	public void start(final BundleContext context) throws Exception {
	      final ServiceReference serviceRef = context.getServiceReference(RemoteOSGiService.class.getName());
	      if (serviceRef == null) {
	          System.out.println("R-OSGi service not found!");
	      } else {
	          final RemoteOSGiService remote = (RemoteOSGiService) context.getService(serviceRef);
	          try {
	              remote.connect(new URI("r-osgi://192.168.23.96:9278"));

	              final RemoteServiceReference[] references = remote.getRemoteServiceReferences(
	                  new URI("r-osgi://192.168.23.96:9278"), IHello.class.getName(), null);
	              if (references == null) {
	                  System.out.println("Service not found!");
	              } else {
	                  final IHello hello = (IHello) remote.getRemoteService(references[0]);
	                  System.out.println(hello.sayHello(System.getProperty("os.name")));
	              }
	          } finally {
	              context.ungetService(serviceRef);
	          }
	      }
	  }
	
	public void stop(BundleContext bundleContext) throws Exception {
		context = null;
	}

}
